#!/usr/bin/env python

#from twisted.internet import pollreactor
#pollreactor.install()
#reactor = pollreactor.PollReactor()
from twisted.internet import reactor
from twisted.internet import threads, defer
from twisted.spread import pb, jelly
from twisted.python import util, threadable
import threading
import Queue
from basics import *
import cPickle
import sys
import SimpleQueue
import os
import time
import imp
import copy
import traceback,sys,cStringIO

#threadable.init()

if os.path.exists(".Twisted") and os.environ.has_key('TWISTEDSERVERS'):
   o = open(".Twisted","r")
   MACHINES = [str(l[:-1].strip()) for l in o.readlines() if l[0] != "#"]
   o.close()
elif os.environ.has_key('TWISTEDSERVERS'):
   MACHINES = os.environ['TWISTEDSERVERS'].split(",")
else:
   MACHINES = ["localhost"]

IMPORTS = {}

orig_path = copy.copy(sys.path)

PORT = 8789

def twisted_import(name,comps=None):
   fo,pn,desc = imp.find_module(name)
   mod = imp.load_module(name,fo,pn,desc)
   fo.close()
   IMPORTS[name] = mod
   if comps == "*":
     s = "from %s import *" % (name)
     for k in dir(IMPORTS[name]):
       globals()[k] = getattr(IMPORTS[name],k)
   elif comps:
     s = "from %s import %s" % (name,comps)
     for k in comps.split(","):
       globals()[k] = getattr(IMPORTS[name],k)
   else:
     s = "import %s" % (name)
     globals()[name] = IMPORTS[name]
   print s
   return s

class SpawnVerbex(pb.Root):
   def remote_verbex(self,pathcommand):
      path = pathcommand["path"]
      command = pathcommand["command"]
      environment = pathcommand["environment"]
      print "Changing current working directory to %s." % (path)
      os.chdir(path)
      sys.stdout.flush()
      for item in environment:
          os.environ[item] = environment[item]
      verbex(command)
      print
      print "Done"
      print
      return 0

class TwistedVerbexQueue:
   def __init__(self,commands,environment={}):
     self.commands = commands
     self.environment = environment
   def Run(self):
     print "Using:",MACHINES
     SimpleQueue.RunForkedQueue(self.Spawn,self.commands,MaxThreads=len(MACHINES),monitor=0)
   def Spawn(self,command):
     for machine in MACHINES:
        if not os.path.exists("/tmp/twisted%d.%s" % (os.getppid(),machine)): break
     lock = open("/tmp/twisted%s.%s" % (os.getppid(),machine),"w")
     lock.close()
     print "Spawning to %s." % (machine)
     factory = pb.PBClientFactory()
     reactor.connectTCP(machine,PORT,factory)
     d = factory.getRootObject()
     cwd = os.getcwd()
     op,host = os.uname()[:2]
     if op == "Darwin":
        cwd = "/".join(["/home"] + host.split(".")[:1]+cwd.split("/")[1:])
     if "shimura" in machine:
        if "mifune" in cwd:
           cwd = cwd.split("/")
           cwd = "/".join(["/Network",cwd[1]]+cwd[3:])
        elif "shimura" in cwd:
           cwd = cwd.split("/")
           cwd = "/".join(["/Users"]+cwd[3:])
     pathcommand = {"path":cwd,"command":command,"environment":self.environment}
     d.addCallback(lambda object: object.callRemote("verbex",pathcommand))
     d.addCallback(lambda response: "return value: %r" % (response))
     d.addErrback(lambda reason: "error: %r" % (reason.value))
     d.addCallback(util.println)
     d.addCallback(lambda _: reactor.stop())
     reactor.run()
     print "Removing %s" % ("/tmp/twisted%s.%s" % (os.getppid(),machine))
     os.remove("/tmp/twisted%s.%s" % (os.getppid(),machine))

class SpawnObject(pb.Root):
   def StartModules(self,add_modules,add_fmodules):
      self.added = []
      self.fadded = []
      self.modules = []
      self.fmodules = []
      if add_modules.split(","): self.modules += add_modules.split(",")
      if add_fmodules.split(","): self.fmodules += add_fmodules.split(",")
   def remote_func(self,obj_dict):
      try:
         path = obj_dict["path"]
         print "Changing current working directory to %s." % (path)
         os.chdir(path)
         sys.path = orig_path + [path]
         sys.stdout.flush()
         func = obj_dict["func"]
         dict = cPickle.loads(obj_dict["dict"])
         if "environ" in obj_dict:
            newenviron = cPickle.loads(obj_dict["environ"])
            print "Loading environment variables."
            for item in newenviron:
                os.environ[item] = newenviron[item]
#                print item, os.environ[item]
         if "args" not in dict: dict["args"] = []
         if "keywords" not in dict: dict["keywords"] = {}
         if "modules" in dict:
            [twisted_import(m) for m in dict["modules"] if m]
         if "fmodules" in dict:
            [twisted_import(m,"*") for m in dict["fmodules"] if m]
         if self.modules:
            [(twisted_import(m),self.added.append(m)) for m in self.modules if m and m not in self.added]
         if self.fmodules:
            [(twisted_import(m,"*"),self.fadded.append(m)) for m in self.fmodules if m and m not in self.fadded]
         value = apply(eval(func),dict["args"],dict["keywords"])
         if "cleanup" in dict: eval(dict["cleanup"])
         print "Done with task."
         status = value
         return status
      except:
         content = sys.stdout = sys.stderr = cStringIO.StringIO()
         traceback.print_exc()
         sys.stdout = sys.__stdout__
         sys.stderr = sys.__stderr__
         status = content.getvalue()
         return status

def TwistedTest(forks=False,threads=False,func=None):
    if not func: func = "lambda value: (time.sleep(2.0),os.uname())[-1]"
    dicts = [{"args":["hello! %s\n" % (machine)]} for machine in MACHINES]
    Q = TwistedObjectQueue(func,dicts)
    Q.repeating = False
    if forks: Q.Run(forks=True)
    elif threads: Q.Run(forks=False)
    else: [Q.Spawn(dict,machine=machine) for dict,machine in zip(dicts,MACHINES)]

def TwistedImport(modules,fmodules):
    func = "lambda value: (sys.stdout.write(value),value)[-1]"
    dicts = [{"args":["hello %s\n" % (machine)],"machine":machine,"modules":modules,"fmodules":fmodules,"path":os.getcwd()} for machine in MACHINES]
    Q = TwistedObjectQueue(func,dicts)
    Q.repeating = False
    Q.threading = True
    [Q.Lock(machine) for dict,machine in zip(Q.dicts,Q.machines)]
    [Q.Unlock(machine) for dict,machine in zip(Q.dicts,Q.machines)]
    nm = len(Q.machines)
    print "suggestThreadPoolSize(%d)" % (nm)
    reactor.suggestThreadPoolSize(nm)
    print "Sending"
    dcall = lambda dict: reactor.callFromThread(Q.Spawn,dict)
    def rwait():
       [reactor.callFromThread(dcall,dict) for dict in Q.dicts]
       while len(Q.results) < nm:
          print "Waiting", len(Q.results),nm
          time.sleep(0.5)
       print "Stopping"
       reactor.callFromThread(reactor.disconnectAll)
       reactor.callFromThread(reactor.removeAll)
       reactor.callFromThread(reactor.stop)
    reactor.callInThread(rwait)
    print "Running"
    reactor.run()
    [Q.Unlock(machine) for dict,machine in zip(Q.dicts,Q.machines)]

class TwistedObjectQueue:
   def __init__(self,func=None,dicts=[{}],PickledOutput=False,environ={}):
     reactor.__init__()
     reactor._initThreadPool()
     self.repeatable = True
     self.repeating = True
     self.threading = False
     self.environ = environ
     self.func = func
     self.pickled = PickledOutput
     self.children = {}
     self.origdicts = copy.copy(dicts)
     self.dicts = dicts
     self.repeat = []
     self.wdict = {}
     self.ddict = {}
     self.results = {}
     self.pid = os.getpid()
     if os.path.exists(".Twisted"):
        o = open(".Twisted","r")
        machines = [str(l[:-1].strip()).split(":") for l in o.readlines() if l[0] != "#"]
        o.close()
     else:
        machines = [machine.split(":") for machine in MACHINES]
     self.machines = [machine[0] for machine in machines]
     print self.machines
#     self.simult = [(machine[1:] and int(machine[1])) or 1 for machine in MACHINES]
   def Run(self,forks=False,sleeptime=0.2):
     print "Using:",self.machines
     if len(self.machines) == 1: map(self.Spawn,self.dicts)
     elif forks: self.RunWithForks(sleeptime=sleeptime)
     else: self.RunWithThreads(sleeptime=sleeptime)
#     print self.results
   def RunWithThreads(self,sleeptime=0.1):
     self.threading = True
     self.wdict = {}
     while self.dicts:
        nd = len(self.dicts)
        nm = len(self.machines)
        nw = min([nm,nd])+2
        print "suggestThreadPoolSize(%d)" % (nw)
        reactor.suggestThreadPoolSize(nw)
        reactor.callInThread(self.Watch,sleeptime)
        reactor.run()
        if self.repeat:
           print "Repeating %d items." % (len(self.repeat))
           self.dicts = self.repeat
           self.repeat = []
   def End(self):
     [self.Unlock(m) for m in self.ddict]
     reactor.stop()
   def Watch(self,sleeptime=1.0):
     ncheck = 0
     nresults = len(self.results)
     while self.repeat+self.dicts or len(self.wdict.keys()):
        while 0 < len(self.wdict.keys()) < len(self.machines) or self.repeat+self.dicts:
           ncheck += 1
           while self.repeat+self.dicts and len(self.wdict.keys()) < len(self.machines):
#              if len(self.results) != nresults:
#                 newresults = len(self.results) - nresults
#                 for result in self.results[-newresults:]: util.println(result)
#                 nresults = len(self.results)
              if self.repeat:
                  dict = self.repeat.pop(0)
                  print "Repeating:",dict
              else: dict = self.dicts.pop(0)
              print len(self.dicts),"items left"
              machine = self.PickMachine(dict,None)
              reactor.callFromThread(self.Go,dict,machine)
           time.sleep(sleeptime)
     time.sleep(sleeptime)
     reactor.callFromThread(self.End)
   def RunWithForks(self,sleeptime=0.1):
#        SimpleQueue.RunForkedQueue(self.Spawn,self.dicts,sleeptime=sleeptime,MaxThreads=len(self.machines),monitor=0,verb=0)
        new = True
        npops = 0
        nchild = 0
        while len(self.dicts) or self.children:
            if len(self.children.keys()) < len(self.machines) and new and len(self.dicts):
               dict = self.dicts.pop(0)
               npops += 1
            else: dict = None
            if dict and len(self.children.keys()) < len(self.machines):
                machine = self.PickMachine(dict)
                child = os.fork()
                if child == 0:
                   status = self.Go(dict,machine)
                   if status: os._exit(1)
                   else: os._exit(0)
                else:
                   while not self.LockFile(machine):
                       time.sleep(sleeptime)
                   self.children[machine] = (child,self.fstat(machine))
                   nchild += 1
                   print "Spawned",machine,child,nchild,len(self.children.keys()),npops,len(self.dicts)
            else:
               time.sleep(sleeptime)
               kill = []
               new = False
#               print self.children
               for machine in self.children:
                  if not self.Check(machine) or (self.Check(machine) and \
                       self.fstat(machine) != self.children[machine][1]):
                       kill.append(machine)
               for machine in kill:
                  new = True
                  del self.children[machine]
   def PickMachine(self,dict,machine=None,machines=None):
     if not machine and "machine" not in dict:
        if machines:
           self.machines = [machine[0] for machine in machines]
        elif os.path.exists(".Twisted"):
           o = open(".Twisted","r")
           machines = [str(l[:-1].strip()).split(":") for l in o.readlines() if l[0] != "#"]
           self.machines = [machine[0] for machine in machines]
           o.close()
        umachine = None
        while not umachine:
           for machine in self.machines:
              if machine not in self.wdict and machine not in self.children and not self.Check(machine):
                  umachine = machine
                  break
           if umachine:
             machine = umachine
             print "Going with %s." % (machine)
             break
           print "Waiting for a machine to open...."
           time.sleep(0.1)
     elif "machine" in dict:
        machine = dict["machine"]
     self.Lock(machine)
     return machine
   def LockFile(self,machine):
     if not os.path.exists("/tmp/twisted"): os.mkdir("/tmp/twisted")
     return "/tmp/twisted/twisted%s.%s" % (self.pid,machine)
   def fstat(self,machine):
     if self.Check(machine):
        try: 
          fd = os.open(self.LockFile(machine),os.O_RDONLY)
          s = os.fstat(fd)
          os.close(fd)
          return s
        except:
          return "NotThere"
   def Lock(self,machine):
     if self.Check(machine):
        while self.Check(machine):
           print "Waiting for",machine
           time.sleep(0.1)
     if self.threading:
        if machine not in self.ddict:
           print "creating connector for",machine
           factory = pb.PBClientFactory()
           connector = reactor.connectTCP(machine,PORT,factory)
           self.ddict[machine] = connector
        self.wdict[machine] = 1
     else: lock = open(self.LockFile(machine),"w"); lock.close()
   def Check(self,machine):
     if self.threading: return machine in self.wdict
     return os.path.exists(self.LockFile(machine))
   def Unlock(self,machine):
     if self.Check(machine):
        if self.threading:
            connector = self.ddict[machine]
            if connector.state == "connected": reactor.callFromThread( connector.disconnect)
            self.wdict.pop(machine)
        else: os.remove(self.LockFile(machine))
   def Spawn(self,dict,machine=None):
     machine = self.PickMachine(dict,machine)
     return self.Go(dict,machine)
   def Go(self,dict,machine=None):
     if not machine: machine = self.PickMachine(dict,machine)
     if self.origdicts: idict = self.origdicts.index(dict)
     else: idict = machine
     data=cPickle.dumps(dict)
     cwd = os.getcwd()
     scwd = cwd.split("/")
     op,host = os.uname()[:2]
     if op == "Darwin":
        if scwd[1] == "Users":
           scwd[1] = "home/%s" % (host.split(".")[0])
           cwd = "/".join(scwd)
        elif scwd[1] == "Volumes":
           scwd[1:3] = [scwd[2],host.split(".")[0]]
           cwd = "/".join(scwd)
     obj_dict = {"path":cwd,"func":self.func,"dict":data}
     if self.environ:
         print "Passing environment variables."
         obj_dict["environ"] = cPickle.dumps(self.environ)
     if self.threading:
        connector = self.ddict[machine]
        if connector.state == "disconnected": reactor.callFromThread( connector.connect)
        factory = connector.factory
        d = factory.getRootObject()
        d.addCallback(lambda object: object.callRemote("func",obj_dict))
        d.addErrback(lambda reason: "error: (%s) %r" % (machine,reason.value))
#        d.addCallback(lambda result: util.println(result))
        d.addCallback(lambda result: (result and shape(result) and "error:" in result and self.DoOver(result,dict,machine)) or result)
        if self.pickled:
            d.addCallback(lambda result: "error:" not in result and cPickle.loads(result) or result)
        d.addCallback(lambda result: self.results.setdefault(idict,result))
        d.addCallback(lambda result: self.Unlock(machine))
        return d
     else:
        factory = pb.PBClientFactory()
        reactor.connectTCP(machine,PORT,factory)
        d = factory.getRootObject()
        d.addCallback(lambda object: object.callRemote("func",obj_dict))
        d.addErrback(lambda reason: "error: (%s) %r" % (machine,reason.value))
        d.addCallback(lambda result:(self.Unlock(machine),util.println(result)))
        d.addCallback(lambda _: reactor.stop())
        reactor.run()
#        while not d.called: print "Waiting for completion...."
#        self.Unlock(machine)
        return d
     del data
   def DoOver(self,result,dict,machine):
       print result
       if self.repeating:
          print "Need to repeat",dict
          if self.repeatable: self.repeat.append(dict)
       if machine in self.machines:
#           connector = self.ddict[machine]
#           if connector.state == "connected": reactor.callFromThread( connector.disconnect)
#           print "creating connector for",machine
#           factory = pb.PBClientFactory()
#           connector = reactor.connectTCP(machine,PORT,factory)
#           self.ddict[machine] = connector
          print "Removing",machine
          self.machines.remove(machine)
          self.Unlock(machine)
          print "Down to ",self.machines
       return result

