#
#  Written by Dan Magee (I think he wrote it...)
#  Slightly modified by D.Kelson
#
from basics import *
from Numeric import *
from Multipack import *
from MLab import *

# The mathematical model.
def gaussian(parameters, data, x):
	""" Parameters: a0 = height of exp, a1 = center of exp, a2 = sigma
	(the width), a3 = constant term, a4 = linear term"""
	a0 = parameters[0]
	a1 = parameters[1]
	a2 = parameters[2]
	a3 = parameters[3]
	a4 = parameters[4]
	return a0*exp(-(((x-a1)/a2)**2)/2) + a3 + a4*x - data

def line(parameters, data, x):
	a0 = parameters[0]
	a1 = parameters[1]
	return a0 + a1*x - data

# Estimate parameters
def eparams(data,x=None,emission=1):
        if not emission: data=-data
	avg = add.reduce(data)/len(data)
	if not x: x = arange(len(data))	
	slope = 0
	intercept = minimum.reduce(data)
	fdata = data - line([intercept,slope],0,x)
	max = abs(maximum.reduce(fdata))
	min = abs(minimum.reduce(fdata))
	if max > min:
		center = argmax(fdata)
		point = fdata[center]*1/exp(1.0)
#                width = 2*simpinterp(point,fdata[center:],x)
		width = 2*(searchsorted(fdata[center:],point) - 1)
		height = fdata[center]
		center = x[center]
	else:
		center = argsort(fdata)[:1][0]
		point = fdata[center]*1/exp(1.0)
		width = 2*(searchsorted(fdata[center:],point) - 1)
		height = minimum.reduce(fdata)
		center = x[center]
	width = 3*(x[1]-x[0])
        if not emission: height=-height;intercept=-intercept;slope=-slope
	return [height,center,width,intercept,slope]

# Fit
def gaussfit(data,x=None,emission=1):
	if not x: x = arange(len(data))
	parameters = eparams(data,x,emission)
	fit = leastsq(gaussian,parameters,args=(data,x))[0].tolist()
	return fit

